package com.dsic.gj_erp.controller.txzz;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.txzz.DmProject;
import com.dsic.gj_erp.service.txzz.DmProjectService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * @version V1.0.0
 * @Title: ProjectController
 * @Package com.dsic.xzerp.dao.scgl.base
 * @Description: 军品部下 船只管理接口
 * @author: xhj
 * @date: 2021/7/20 15:48
 */
@RestController
@RequestMapping("/api/scgl/project")
public class ProjectController {

    @Autowired
    DmProjectService dmProjectService;


    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody Map<String, String> paramMap){
        QueryWrapper <DmProject>queryWrapper =new QueryWrapper();
        if(StringUtils.isNotBlank(paramMap.get("project"))){
            queryWrapper.eq("project",paramMap.get("project"));
        }
        if(StringUtils.isNotBlank(paramMap.get("kgrq"))){
            queryWrapper.ge("start_date",paramMap.get("kgrq"));
        }
        if(StringUtils.isNotBlank(paramMap.get("kgrq1"))){
            queryWrapper.le("start_date",paramMap.get("kgrq1"));
        }
        if(StringUtils.isNotBlank(paramMap.get("shrq"))){
            queryWrapper.ge("sail_date",paramMap.get("shrq"));
        }
        if(StringUtils.isNotBlank(paramMap.get("shrq1"))){
            queryWrapper.le("sail_date",paramMap.get("shrq1"));
        }
        queryWrapper.orderBy(true,true,"project");
            return new ResultBean(dmProjectService.list(queryWrapper));
    }
    @PostMapping(value = "/add")
    public ResultBean add(HttpServletRequest httpRequest , @RequestBody List<DmProject>  dmProjects) {
        dmProjectService.saveBaths(httpRequest,dmProjects);
        return  new  ResultBean();
    }

    @PostMapping(value = "/del")
    public ResultBean del(@RequestBody List<String> delArr) {
        dmProjectService.removeByIds(delArr);
        return  new  ResultBean();
    }

    @PostMapping(value = "/update")
    public ResultBean update(@RequestBody List<DmProject> dmProjects) {
        dmProjectService.updateBatchById(dmProjects);
        return  new  ResultBean();
    }

    @PostMapping(value = "/base")
    public ResultBean  getbase(@RequestBody Map<String, Object> paramMap){
        return new ResultBean<>( dmProjectService.mpGetBase(paramMap));
    }


}
