package com.dsic.gj_erp.service.fd.impl;

import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.bean.fd.TppsQk;
import com.dsic.gj_erp.mapper.fd.TpbMapper;
import com.dsic.gj_erp.util.MyString;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xhj
 * @since 2023-05-08
 */
@Service
public class TpImpl {
    @Autowired
    TpbMapper tpbMapper;

    public List<Map> findTPxqjh(Map map) {
        List<Map> tPxqjhs = tpbMapper.findTPxqjh(map);
        //需求反馈预估天数差xqtsc
        // 有反馈用反馈 没有用预估
        for(Map map1:tPxqjhs){
            String one = "";
            String two = "";
            String fkpprq =(String)map1.get("fkpprq"); //反馈配送期
            String ygpprq =(String)map1.get("ygpprq"); //预计配送期
            if(StringUtils.isNotBlank(fkpprq)){
                one=fkpprq;
            }else if(StringUtils.isNotBlank(ygpprq)){
                one=ygpprq;
                String qfxqrq =(String)map1.get("qfxqrq"); // 前方实际需求
                String jhxqrq =(String)map1.get("jhxqrq"); //集团三月滚动计划期
                String fdxqrq =(String)map1.get("fdxqrq"); //分段计划需求期
                if(StringUtils.isNotBlank(qfxqrq)){
                    two=qfxqrq;
                }else if (StringUtils.isNotBlank(fdxqrq)){
                    two=fdxqrq;
                }else{
                    two=jhxqrq;
                }
                // 日期相检查
                Date oneDate = DateUtil.parse(one);
                Date twoDate = DateUtil.parse(two);
//                long betweenDay = DateUtil.between(twoDate, oneDate, DateUnit.DAY);
                long betweenDay=   MyString.differentDays(oneDate,twoDate);
                map1.put("xqtsc",betweenDay);
            }else{
                map1.put("xqtsc","");
            }

        }

        return tPxqjhs;
    }

    public List<TppsQk> findTppsQk(Map map) {
        List<TppsQk> tppsQks = tpbMapper.findTppsQk(map);
        for (TppsQk t : tppsQks) {
//            if(t.getPssl().compareTo(new BigDecimal("100"))==0){
//                if(StringUtils.isNotBlank(t.getps))
//
//            }else
            //最小值 不为空 不用显示了

            if (StringUtils.isNotBlank(t.getQfpsrq())) {
               // t.setYjtgq(t.getQfpsrq1());

                //最小的不爲空 用最大的 jprkrq

            } else if (StringUtils.isNotBlank(t.getMinjprkrq())){

                Date date = DateUtil.parse(t.getMaxjprkrq());

                    t.setYgpprq(DateUtil.format( DateUtil.offsetDay(date, 2), "yyyy/MM/dd"));
                //System.out.println("date = " + t.getMaxjprkrq()+"111"+t.getYgpprq());

            } else if (StringUtils.isNotBlank(t.getFkpprq())) { //反馈配送
                t.setYjtgq(t.getFkpprq());
            } else if (StringUtils.isNotBlank(t.getYgpprq())) {
                t.setYjtgq(t.getYgpprq());
            } else {
                t.setYjtgq("");
            }
            if ("9999/99/99".equals(t.getSjpsrqmax())) {
                    t.setSjpsrqmax("");
            }

            if(t.getXqsl().compareTo(t.getPssl())==0){

            }else{
                t.setPssl0(((t.getPssl().add(t.getPssl0())).divide(t.getXqsl(),BigDecimal.ROUND_HALF_UP).multiply(new BigDecimal("100.0"))).setScale(2, BigDecimal.ROUND_HALF_UP) );
                t.setPssl5(((t.getPssl().add(t.getPssl5())).divide(t.getXqsl(),BigDecimal.ROUND_HALF_UP).multiply(new BigDecimal("100.0"))).setScale(2, BigDecimal.ROUND_HALF_UP) );
                t.setPssl10(((t.getPssl().add(t.getPssl10())).divide(t.getXqsl(),BigDecimal.ROUND_HALF_UP).multiply(new BigDecimal("100.0"))).setScale(2, BigDecimal.ROUND_HALF_UP) );
                t.setPssl15(((t.getPssl().add(t.getPssl15())).divide(t.getXqsl(),BigDecimal.ROUND_HALF_UP).multiply(new BigDecimal("100.0"))).setScale(2, BigDecimal.ROUND_HALF_UP) );
            }


        }
        return tppsQks;
    }
}
